-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Gantt - Task Template
The DevExtreme JavaScript Gantt templates help customize the layout and appearance of individual task elements. Templates allow you to mix HTML code with any DevExtreme JavaScript component - and position desired elements within the container. In this demo, a template is used to display images within tasks and change their background color.
Backend API
$(() => {
$('#gantt').dxGantt({
taskTitlePosition: 'outside',
scaleType: 'days',
tasks: {
dataSource: tasks,
},
dependencies: {
dataSource: dependencies,
},
resources: {
dataSource: resources,
},
resourceAssignments: {
dataSource: resourceAssignments,
},
editing: {
enabled: true,
},
columns: [{
dataField: 'title',
caption: 'Subject',
width: 300,
}, {
dataField: 'start',
caption: 'Start Date',
}, {
dataField: 'end',
caption: 'End Date',
}],
taskListWidth: 500,
taskContentTemplate: getTaskContentTemplate,
}).dxGantt('instance');
function getImagePath(taskId) {
const imgPath = '../../../../images/employees/';
let img = taskId < 10 ? `0${taskId}` : taskId;
img = `${imgPath + img}.png`;
return img;
}
function getTaskContentTemplate(item) {
const resource = item.taskResources[0];
const img = getImagePath(item.taskData.id);
const color = item.taskData.id % 6;
const $customContainer = $(document.createElement('div'))
.addClass('custom-task')
.css('width', `${item.taskSize.width}px`)
.addClass(`custom-task-color-${color}`);
const $imgWrapper = $(document.createElement('div'))
.addClass('custom-task-img-wrapper')
.appendTo($customContainer);
$(document.createElement('img'))
.addClass('custom-task-img')
.attr({
src: resource ? img : 'unknown.png',
alt: 'imageAlt',
})
.appendTo($imgWrapper);
const $wrapper = $(document.createElement('div'))
.addClass('custom-task-wrapper')
.appendTo($customContainer);
$(document.createElement('div'))
.addClass('custom-task-title')
.text(item.taskData.title)
.appendTo($wrapper);
$(document.createElement('div'))
.addClass('custom-task-row')
.text(resource ? resource.text : '')
.appendTo($wrapper);
$(document.createElement('div'))
.addClass('custom-task-progress')
.css('width', `${parseFloat(item.taskData.progress)}%`)
.appendTo($customContainer);
return $customContainer;
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="https://cdn3.devexpress.com/jslib/26.1.3/js/dx-gantt.min.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx-gantt.min.css" />
<script src="js/dx.all.js?v=26.1.3"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="gantt"> </div>
</div>
</body>
</html>
#gantt {
height: 700px;
}
.custom-task-color-0 {
background-color: #512DA8;
}
.custom-task-color-1 {
background-color: #2E7D32;
}
.custom-task-color-2 {
background-color: #1564C0;
}
.custom-task-color-3 {
background-color: #C2185B;
}
.custom-task-color-4 {
background-color: #C62828;
}
.custom-task-color-5 {
background-color: #DD2C00;
}
.custom-task-color-6 {
background-color: #7B1FA2;
}
.custom-task {
max-height: 48px;
height: 100%;
display: block;
overflow: hidden;
}
.custom-task-wrapper {
padding: 8px;
color: #fff;
}
.custom-task-wrapper > * {
display: block;
overflow: hidden;
text-overflow: ellipsis;
}
.custom-task-img-wrapper {
float: left;
width: 32px;
height: 32px;
border-radius: 50%;
margin: 8px;
background-color: #fff;
overflow: hidden;
}
.custom-task-img {
width: 32px;
}
.custom-task-title {
font-weight: 600;
font-size: 13px;
}
.custom-task-row {
font-size: 11px;
}
.custom-task-progress {
position: absolute;
left: 0;
bottom: 0;
width: 0%;
height: 4px;
background: rgba(0, 0, 0, 0.3);
}
.dx-gantt .dx-row {
height: 63px;
}
const currentDate = new Date(Date.now());
const month = currentDate.getMonth();
const year = currentDate.getFullYear();
const tasks = [{
id: 1,
parentId: 0,
title: 'Analysis/Software Requirements',
start: new Date(year, month, 1),
end: new Date(year, month, 28),
progress: 31,
}, {
id: 2,
parentId: 1,
title: 'Conduct needs analysis',
start: new Date(year, month, 1),
end: new Date(year, month, 3),
progress: 15,
}, {
id: 3,
parentId: 1,
title: 'Draft preliminary software specifications',
start: new Date(year, month, 3),
end: new Date(year, month, 5),
progress: 30,
}, {
id: 4,
parentId: 1,
title: 'Review software specifications/budget with team',
start: new Date(year, month, 4),
end: new Date(year, month, 6),
progress: 60,
}, {
id: 5,
parentId: 1,
title: 'Incorporate feedback on software specifications',
start: new Date(year, month, 6),
end: new Date(year, month, 8),
progress: 45,
}, {
id: 6,
parentId: 1,
title: 'Develop delivery timeline',
start: new Date(year, month, 8),
end: new Date(year, month, 14),
progress: 15,
}, {
id: 7,
parentId: 1,
title: 'Obtain approvals to proceed (concept, timeline, budget)',
start: new Date(year, month, 14),
end: new Date(year, month, 20),
progress: 15,
}, {
id: 8,
parentId: 1,
title: 'Draft preliminary software specifications',
start: new Date(year, month, 20),
end: new Date(year, month, 25),
progress: 0,
}, {
id: 9,
parentId: 1,
title: 'Secure required resources',
start: new Date(year, month, 25),
end: new Date(year, month, 28),
progress: 0,
},
];
const dependencies = [{
id: 1,
predecessorId: 2,
successorId: 3,
type: 0,
}, {
id: 2,
predecessorId: 3,
successorId: 4,
type: 0,
}, {
id: 3,
predecessorId: 4,
successorId: 5,
type: 0,
}, {
id: 4,
predecessorId: 5,
successorId: 6,
type: 0,
}, {
id: 5,
predecessorId: 6,
successorId: 7,
type: 0,
}, {
id: 6,
predecessorId: 7,
successorId: 8,
type: 0,
}, {
id: 7,
predecessorId: 8,
successorId: 9,
type: 0,
}];
const resources = [{
id: 1,
text: 'John Heart',
}, {
id: 2,
text: 'Paul Peyton',
}, {
id: 3,
text: 'Robert Reagan',
}, {
id: 4,
text: 'Greta Sims',
}, {
id: 5,
text: 'Brett Wade',
}, {
id: 6,
text: 'Sandra Johnson',
}, {
id: 7,
text: 'Kevin Carter',
}, {
id: 8,
text: 'Cynthia Stanwick',
}, {
id: 9,
text: 'Olivia Samuelson',
}];
const resourceAssignments = [{
id: 0,
taskId: 1,
resourceId: 1,
}, {
id: 1,
taskId: 2,
resourceId: 2,
}, {
id: 2,
taskId: 3,
resourceId: 3,
}, {
id: 3,
taskId: 4,
resourceId: 4,
}, {
id: 4,
taskId: 5,
resourceId: 5,
}, {
id: 5,
taskId: 6,
resourceId: 6,
}, {
id: 6,
taskId: 7,
resourceId: 7,
}, {
id: 7,
taskId: 8,
resourceId: 8,
}, {
id: 8,
taskId: 9,
resourceId: 9,
}];
Implementation: Use the taskContentTemplate template to customize and align task information within the template container. For each task, use the item property to obtain task information (title, resource, progress) and wrap it into div elements. Then, apply CSS styles to these div elements and place them into the container.

Backend API
import React from 'react';
import Gantt, {
Tasks, Dependencies, Resources, ResourceAssignments, Column, Editing,
} from 'devextreme-react/gantt';
import {
tasks, dependencies, resources, resourceAssignments,
} from './data.ts';
import TaskTemplate from './TaskTemplate.tsx';
function App() {
return (
<div id="form-demo">
<div className="widget-container">
<Gantt
taskListWidth={500}
height={700}
scaleType="days"
taskContentRender={TaskTemplate}>
<Tasks dataSource={tasks} />
<Dependencies dataSource={dependencies} />
<Resources dataSource={resources} />
<ResourceAssignments dataSource={resourceAssignments} />
<Column dataField="title" caption="Subject" width={300} />
<Column dataField="start" caption="Start Date" />
<Column dataField="end" caption="End Date" />
<Editing enabled />
</Gantt>
</div>
</div>
);
}
export default App;
import React from 'react';
import Gantt, {
Tasks,
Dependencies,
Resources,
ResourceAssignments,
Column,
Editing,
} from 'devextreme-react/gantt';
import {
tasks, dependencies, resources, resourceAssignments,
} from './data.js';
import TaskTemplate from './TaskTemplate.js';
function App() {
return (
<div id="form-demo">
<div className="widget-container">
<Gantt
taskListWidth={500}
height={700}
scaleType="days"
taskContentRender={TaskTemplate}
>
<Tasks dataSource={tasks} />
<Dependencies dataSource={dependencies} />
<Resources dataSource={resources} />
<ResourceAssignments dataSource={resourceAssignments} />
<Column
dataField="title"
caption="Subject"
width={300}
/>
<Column
dataField="start"
caption="Start Date"
/>
<Column
dataField="end"
caption="End Date"
/>
<Editing enabled />
</Gantt>
</div>
</div>
);
}
export default App;
import React from 'react';
interface TaskTemplateProps {
taskData: {
id: number;
title: string;
progress: number;
};
taskSize: {
width: number;
height: number;
};
taskResources: { text: string }[];
}
function getImagePath(taskId: number) {
const imgPath = '../../../../images/employees';
let img = taskId < 10 ? `0${taskId}` : taskId;
img = `${imgPath}/${img}.png`;
return img;
}
function getTaskColor(taskId: number) {
const color = taskId % 6;
return `custom-task-color-${color}`;
}
export default function TaskTemplate({ taskData, taskSize, taskResources }: TaskTemplateProps) {
return (
<div className={`custom-task ${getTaskColor(taskData.id)}`} style={ { width: `${taskSize.width}px` } }>
<div className="custom-task-img-wrapper">
<img className="custom-task-img" src={getImagePath(taskData.id)} />
</div>
<div className='custom-task-wrapper'>
<div className='custom-task-title'>{taskData.title}</div>
<div className='custom-task-row'>{taskResources[0].text}</div>
</div>
<div className='custom-task-progress' style={ { width: `${taskData.progress}%` } }></div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const currentDate = new Date(Date.now());
const month = currentDate.getMonth();
const year = currentDate.getFullYear();
export const tasks = [{
id: 1,
parentId: 0,
title: 'Analysis/Software Requirements',
start: new Date(year, month, 1),
end: new Date(year, month, 28),
progress: 31,
}, {
id: 2,
parentId: 1,
title: 'Conduct needs analysis',
start: new Date(year, month, 1),
end: new Date(year, month, 3),
progress: 15,
}, {
id: 3,
parentId: 1,
title: 'Draft preliminary software specifications',
start: new Date(year, month, 3),
end: new Date(year, month, 5),
progress: 30,
}, {
id: 4,
parentId: 1,
title: 'Review software specifications/budget with team',
start: new Date(year, month, 4),
end: new Date(year, month, 6),
progress: 60,
}, {
id: 5,
parentId: 1,
title: 'Incorporate feedback on software specifications',
start: new Date(year, month, 6),
end: new Date(year, month, 8),
progress: 45,
}, {
id: 6,
parentId: 1,
title: 'Develop delivery timeline',
start: new Date(year, month, 8),
end: new Date(year, month, 14),
progress: 15,
}, {
id: 7,
parentId: 1,
title: 'Obtain approvals to proceed (concept, timeline, budget)',
start: new Date(year, month, 14),
end: new Date(year, month, 20),
progress: 15,
}, {
id: 8,
parentId: 1,
title: 'Draft preliminary software specifications',
start: new Date(year, month, 20),
end: new Date(year, month, 25),
progress: 0,
}, {
id: 9,
parentId: 1,
title: 'Secure required resources',
start: new Date(year, month, 25),
end: new Date(year, month, 28),
progress: 0,
}];
export const dependencies = [{
id: 1,
predecessorId: 2,
successorId: 3,
type: 0,
}, {
id: 2,
predecessorId: 3,
successorId: 4,
type: 0,
}, {
id: 3,
predecessorId: 4,
successorId: 5,
type: 0,
}, {
id: 4,
predecessorId: 5,
successorId: 6,
type: 0,
}, {
id: 5,
predecessorId: 6,
successorId: 7,
type: 0,
}, {
id: 6,
predecessorId: 7,
successorId: 8,
type: 0,
}, {
id: 7,
predecessorId: 8,
successorId: 9,
type: 0,
}];
export const resources = [{
id: 1,
text: 'John Heart',
}, {
id: 2,
text: 'Paul Peyton',
}, {
id: 3,
text: 'Robert Reagan',
}, {
id: 4,
text: 'Greta Sims',
}, {
id: 5,
text: 'Brett Wade',
}, {
id: 6,
text: 'Sandra Johnson',
}, {
id: 7,
text: 'Kevin Carter',
}, {
id: 8,
text: 'Cynthia Stanwick',
}, {
id: 9,
text: 'Olivia Samuelson',
}];
export const resourceAssignments = [{
id: 0,
taskId: 1,
resourceId: 1,
}, {
id: 1,
taskId: 2,
resourceId: 2,
}, {
id: 2,
taskId: 3,
resourceId: 3,
}, {
id: 3,
taskId: 4,
resourceId: 4,
}, {
id: 4,
taskId: 5,
resourceId: 5,
}, {
id: 5,
taskId: 6,
resourceId: 6,
}, {
id: 6,
taskId: 7,
resourceId: 7,
}, {
id: 7,
taskId: 8,
resourceId: 8,
}, {
id: 8,
taskId: 9,
resourceId: 9,
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
function getImagePath(taskId) {
const imgPath = '../../../../images/employees';
let img = taskId < 10 ? `0${taskId}` : taskId;
img = `${imgPath}/${img}.png`;
return img;
}
function getTaskColor(taskId) {
const color = taskId % 6;
return `custom-task-color-${color}`;
}
export default function TaskTemplate({ taskData, taskSize, taskResources }) {
return (
<div
className={`custom-task ${getTaskColor(taskData.id)}`}
style={{ width: `${taskSize.width}px` }}
>
<div className="custom-task-img-wrapper">
<img
className="custom-task-img"
src={getImagePath(taskData.id)}
/>
</div>
<div className="custom-task-wrapper">
<div className="custom-task-title">{taskData.title}</div>
<div className="custom-task-row">{taskResources[0].text}</div>
</div>
<div
className="custom-task-progress"
style={{ width: `${taskData.progress}%` }}
></div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const currentDate = new Date(Date.now());
const month = currentDate.getMonth();
const year = currentDate.getFullYear();
export const tasks = [
{
id: 1,
parentId: 0,
title: 'Analysis/Software Requirements',
start: new Date(year, month, 1),
end: new Date(year, month, 28),
progress: 31,
},
{
id: 2,
parentId: 1,
title: 'Conduct needs analysis',
start: new Date(year, month, 1),
end: new Date(year, month, 3),
progress: 15,
},
{
id: 3,
parentId: 1,
title: 'Draft preliminary software specifications',
start: new Date(year, month, 3),
end: new Date(year, month, 5),
progress: 30,
},
{
id: 4,
parentId: 1,
title: 'Review software specifications/budget with team',
start: new Date(year, month, 4),
end: new Date(year, month, 6),
progress: 60,
},
{
id: 5,
parentId: 1,
title: 'Incorporate feedback on software specifications',
start: new Date(year, month, 6),
end: new Date(year, month, 8),
progress: 45,
},
{
id: 6,
parentId: 1,
title: 'Develop delivery timeline',
start: new Date(year, month, 8),
end: new Date(year, month, 14),
progress: 15,
},
{
id: 7,
parentId: 1,
title: 'Obtain approvals to proceed (concept, timeline, budget)',
start: new Date(year, month, 14),
end: new Date(year, month, 20),
progress: 15,
},
{
id: 8,
parentId: 1,
title: 'Draft preliminary software specifications',
start: new Date(year, month, 20),
end: new Date(year, month, 25),
progress: 0,
},
{
id: 9,
parentId: 1,
title: 'Secure required resources',
start: new Date(year, month, 25),
end: new Date(year, month, 28),
progress: 0,
},
];
export const dependencies = [
{
id: 1,
predecessorId: 2,
successorId: 3,
type: 0,
},
{
id: 2,
predecessorId: 3,
successorId: 4,
type: 0,
},
{
id: 3,
predecessorId: 4,
successorId: 5,
type: 0,
},
{
id: 4,
predecessorId: 5,
successorId: 6,
type: 0,
},
{
id: 5,
predecessorId: 6,
successorId: 7,
type: 0,
},
{
id: 6,
predecessorId: 7,
successorId: 8,
type: 0,
},
{
id: 7,
predecessorId: 8,
successorId: 9,
type: 0,
},
];
export const resources = [
{
id: 1,
text: 'John Heart',
},
{
id: 2,
text: 'Paul Peyton',
},
{
id: 3,
text: 'Robert Reagan',
},
{
id: 4,
text: 'Greta Sims',
},
{
id: 5,
text: 'Brett Wade',
},
{
id: 6,
text: 'Sandra Johnson',
},
{
id: 7,
text: 'Kevin Carter',
},
{
id: 8,
text: 'Cynthia Stanwick',
},
{
id: 9,
text: 'Olivia Samuelson',
},
];
export const resourceAssignments = [
{
id: 0,
taskId: 1,
resourceId: 1,
},
{
id: 1,
taskId: 2,
resourceId: 2,
},
{
id: 2,
taskId: 3,
resourceId: 3,
},
{
id: 3,
taskId: 4,
resourceId: 4,
},
{
id: 4,
taskId: 5,
resourceId: 5,
},
{
id: 5,
taskId: 6,
resourceId: 6,
},
{
id: 6,
taskId: 7,
resourceId: 7,
},
{
id: 7,
taskId: 8,
resourceId: 8,
},
{
id: 8,
taskId: 9,
resourceId: 9,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx-gantt.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gantt {
height: 700px;
}
.custom-task-color-0 {
background-color: #512DA8;
}
.custom-task-color-1 {
background-color: #2E7D32;
}
.custom-task-color-2 {
background-color: #1564C0;
}
.custom-task-color-3 {
background-color: #C2185B;
}
.custom-task-color-4 {
background-color: #C62828;
}
.custom-task-color-5 {
background-color: #DD2C00;
}
.custom-task-color-6 {
background-color: #7B1FA2;
}
.custom-task {
max-height: 48px;
height: 100%;
display: block;
overflow: hidden;
}
.custom-task-wrapper {
padding: 8px;
color: #fff;
}
.custom-task-wrapper > * {
display: block;
overflow: hidden;
text-overflow: ellipsis;
}
.custom-task-img-wrapper {
float: left;
width: 32px;
height: 32px;
border-radius: 50%;
margin: 8px;
background-color: #fff;
overflow: hidden;
}
.custom-task-img {
width: 32px;
}
.custom-task-title {
font-weight: 600;
font-size: 13px;
}
.custom-task-row {
font-size: 11px;
}
.custom-task-progress {
position: absolute;
left: 0;
bottom: 0;
width: 0%;
height: 4px;
background: rgba(0, 0, 0, 0.3);
}
.dx-gantt .dx-row {
height: 63px;
}
Implementation: Use the taskContentTemplate template to customize and align task information within the template container. For each task, use the item property to obtain task information (title, resource, progress) and wrap it into div elements. Then, apply CSS styles to these div elements and place them into the container.

Backend API
<div id="demo-container">
<div class="widget-container">
<dx-gantt
taskListWidth="500"
height="700"
scaleType="days"
taskContentTemplate="taskContentTemplate"
>
<dxo-gantt-tasks [dataSource]="tasks"></dxo-gantt-tasks>
<dxo-gantt-dependencies
[dataSource]="dependencies"
></dxo-gantt-dependencies>
<dxo-gantt-resources [dataSource]="resources"></dxo-gantt-resources>
<dxo-gantt-resource-assignments
[dataSource]="resourceAssignments"
></dxo-gantt-resource-assignments>
<dxi-gantt-column
dataField="title"
caption="Subject"
[width]="300"
></dxi-gantt-column>
<dxi-gantt-column
dataField="start"
caption="Start Date"
dataType="date"
></dxi-gantt-column>
<dxi-gantt-column
dataField="end"
caption="End Date"
dataType="date"
></dxi-gantt-column>
<dxo-gantt-editing [enabled]="true"></dxo-gantt-editing>
<div
*dxTemplate="let item of 'taskContentTemplate'"
class="custom-task {{ getTaskColor(item.taskData.id) }}"
[style.width]="item.taskSize.width + 'px'"
>
<div class="custom-task-img-wrapper">
<img
class="custom-task-img"
[attr.src]="getImagePath(item.taskData.id)"
/>
</div>
<div class="custom-task-wrapper">
<div class="custom-task-title">{{ item.taskData.title }}</div>
<div class="custom-task-row">{{ item.taskResources[0].text }}</div>
</div>
<div
class="custom-task-progress"
[style.width]="item.taskData.progress + '%'"
></div>
</div>
</dx-gantt>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, ViewEncapsulation, provideZoneChangeDetection } from '@angular/core';
import { DxGanttModule, DxCheckBoxModule, DxSelectBoxModule } from 'devextreme-angular';
import {
Service, Task, Dependency, Resource, ResourceAssignment,
} from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
encapsulation: ViewEncapsulation.None,
imports: [
DxGanttModule,
DxCheckBoxModule,
DxSelectBoxModule,
],
})
export class AppComponent {
tasks: Task[];
dependencies: Dependency[];
resources: Resource[];
resourceAssignments: ResourceAssignment[];
constructor(service: Service) {
this.tasks = service.getTasks();
this.dependencies = service.getDependencies();
this.resources = service.getResources();
this.resourceAssignments = service.getResourceAssignments();
}
getImagePath(taskId) {
const imgPath = '../../../../images/employees';
let img = taskId < 10 ? `0${taskId}` : taskId;
img = `${imgPath}/${img}.png`;
return img;
}
getTaskColor(taskId) {
const color = taskId % 6;
return `custom-task-color-${color}`;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
#gantt {
height: 700px;
}
.custom-task-color-0 {
background-color: #512DA8;
}
.custom-task-color-1 {
background-color: #2E7D32;
}
.custom-task-color-2 {
background-color: #1564C0;
}
.custom-task-color-3 {
background-color: #C2185B;
}
.custom-task-color-4 {
background-color: #C62828;
}
.custom-task-color-5 {
background-color: #DD2C00;
}
.custom-task-color-6 {
background-color: #7B1FA2;
}
.custom-task {
max-height: 48px;
height: 100%;
display: block;
overflow: hidden;
}
.custom-task-wrapper {
padding: 8px;
color: #fff;
}
.custom-task-wrapper > * {
display: block;
overflow: hidden;
text-overflow: ellipsis;
}
.custom-task-img-wrapper {
float: left;
width: 32px;
height: 32px;
border-radius: 50%;
margin: 8px;
background-color: #fff;
overflow: hidden;
}
.custom-task-img {
width: 32px;
}
.custom-task-title {
font-weight: 600;
font-size: 13px;
}
.custom-task-row {
font-size: 11px;
}
.custom-task-progress {
position: absolute;
left: 0;
bottom: 0;
width: 0%;
height: 4px;
background: rgba(0, 0, 0, 0.3);
}
.dx-gantt .dx-row {
height: 63px;
}
import { Injectable } from '@angular/core';
export class Task {
id: number;
parentId: number;
title: string;
start: Date;
end: Date;
progress: number;
}
export class Dependency {
id: number;
predecessorId: number;
successorId: number;
type: number;
}
export class Resource {
id: number;
text: string;
}
export class ResourceAssignment {
id: number;
taskId: number;
resourceId: number;
}
const currentDate: Date = new Date(Date.now());
const month: number = currentDate.getMonth();
const year: number = currentDate.getFullYear();
const tasks: Task[] = [{
id: 1,
parentId: 0,
title: 'Analysis/Software Requirements',
start: new Date(year, month, 1),
end: new Date(year, month, 28),
progress: 31,
}, {
id: 2,
parentId: 1,
title: 'Conduct needs analysis',
start: new Date(year, month, 1),
end: new Date(year, month, 3),
progress: 15,
}, {
id: 3,
parentId: 1,
title: 'Draft preliminary software specifications',
start: new Date(year, month, 3),
end: new Date(year, month, 5),
progress: 30,
}, {
id: 4,
parentId: 1,
title: 'Review software specifications/budget with team',
start: new Date(year, month, 4),
end: new Date(year, month, 6),
progress: 60,
}, {
id: 5,
parentId: 1,
title: 'Incorporate feedback on software specifications',
start: new Date(year, month, 6),
end: new Date(year, month, 8),
progress: 45,
}, {
id: 6,
parentId: 1,
title: 'Develop delivery timeline',
start: new Date(year, month, 8),
end: new Date(year, month, 14),
progress: 15,
}, {
id: 7,
parentId: 1,
title: 'Obtain approvals to proceed (concept, timeline, budget)',
start: new Date(year, month, 14),
end: new Date(year, month, 20),
progress: 15,
}, {
id: 8,
parentId: 1,
title: 'Draft preliminary software specifications',
start: new Date(year, month, 20),
end: new Date(year, month, 25),
progress: 0,
}, {
id: 9,
parentId: 1,
title: 'Secure required resources',
start: new Date(year, month, 25),
end: new Date(year, month, 28),
progress: 0,
}];
const dependencies: Dependency[] = [{
id: 1,
predecessorId: 2,
successorId: 3,
type: 0,
}, {
id: 2,
predecessorId: 3,
successorId: 4,
type: 0,
}, {
id: 3,
predecessorId: 4,
successorId: 5,
type: 0,
}, {
id: 4,
predecessorId: 5,
successorId: 6,
type: 0,
}, {
id: 5,
predecessorId: 6,
successorId: 7,
type: 0,
}, {
id: 6,
predecessorId: 7,
successorId: 8,
type: 0,
}, {
id: 7,
predecessorId: 8,
successorId: 9,
type: 0,
}];
const resources: Resource[] = [{
id: 1,
text: 'John Heart',
}, {
id: 2,
text: 'Paul Peyton',
}, {
id: 3,
text: 'Robert Reagan',
}, {
id: 4,
text: 'Greta Sims',
}, {
id: 5,
text: 'Brett Wade',
}, {
id: 6,
text: 'Sandra Johnson',
}, {
id: 7,
text: 'Kevin Carter',
}, {
id: 8,
text: 'Cynthia Stanwick',
}, {
id: 9,
text: 'Olivia Samuelson',
}];
const resourceAssignments: ResourceAssignment[] = [{
id: 0,
taskId: 1,
resourceId: 1,
}, {
id: 1,
taskId: 2,
resourceId: 2,
}, {
id: 2,
taskId: 3,
resourceId: 3,
}, {
id: 3,
taskId: 4,
resourceId: 4,
}, {
id: 4,
taskId: 5,
resourceId: 5,
}, {
id: 5,
taskId: 6,
resourceId: 6,
}, {
id: 6,
taskId: 7,
resourceId: 7,
}, {
id: 7,
taskId: 8,
resourceId: 8,
}, {
id: 8,
taskId: 9,
resourceId: 9,
}];
@Injectable()
export class Service {
getTasks(): Task[] {
return tasks;
}
getDependencies(): Dependency[] {
return dependencies;
}
getResources(): Resource[] {
return resources;
}
getResourceAssignments(): ResourceAssignment[] {
return resourceAssignments;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx-gantt.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
Implementation: Use the taskContentTemplate template to customize and align task information within the template container. For each task, use the item property to obtain task information (title, resource, progress) and wrap it into div elements. Then, apply CSS styles to these div elements and place them into the container.

DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Gantt - Task Template

The DevExtreme Gantt templates help customize the layout and appearance of individual task elements. Templates allow you to mix HTML code with any DevExtreme JavaScript component - and position desired elements within the container. In this demo, a template is used to display images within tasks and change their background color.

Backend API
<template> <div id="form-demo"> <div class="widget-container"> <DxGantt :task-list-width="500" :height="700" scale-type="days" task-content-template="taskContentTemplate" > <DxTasks :data-source="tasks"/> <DxDependencies :data-source="dependencies"/> <DxResources :data-source="resources"/> <DxResourceAssignments :data-source="resourceAssignments"/> <DxEditing :enabled="true"/> <DxColumn :width="300" data-field="title" caption="Subject" /> <DxColumn data-field="start" caption="Start Date" /> <DxColumn data-field="end" caption="End Date" /> <template #taskContentTemplate="{ data: item }"> <div class="custom-task" :class="getTaskColor(item.taskData.id)" :style="{width: item.taskSize.width + 'px'}" > <div class="custom-task-img-wrapper"> <img class="custom-task-img" :src="getImagePath(item.taskData.id)" > </div> <div class="custom-task-wrapper"> <div class="custom-task-title">{{ item.taskData.title }}</div> <div class="custom-task-row">{{ item.taskResources[0].text }}</div> </div> <div class="custom-task-progress" :style="{width: item.taskData.progress + '%'}" /> </div> </template> </DxGantt> </div> </div> </template> <script setup lang="ts"> import { DxGantt, DxTasks, DxDependencies, DxResources, DxResourceAssignments, DxColumn, DxEditing, } from 'devextreme-vue/gantt'; import { tasks, dependencies, resources, resourceAssignments, } from './data.ts'; const getTaskColor = (taskId: number) => `custom-task-color-${taskId % 6}`; function getImagePath(taskId: number) { const img = taskId < 10 ? `0${taskId}` : taskId; return `../../../../images/employees/${img}.png`; } </script> <style> #gantt { height: 700px; } .custom-task-color-0 { background-color: #5c57c9; } .custom-task-color-1 { background-color: #35b86b; } .custom-task-color-2 { background-color: #4796ce; } .custom-task-color-3 { background-color: #ce4776; } .custom-task-color-4 { background-color: #ce5b47; } .custom-task-color-5 { background-color: #f78119; } .custom-task-color-6 { background-color: #9f47ce; } .custom-task { max-height: 48px; height: 100%; display: block; overflow: hidden; } .custom-task-wrapper { padding: 8px; color: #fff; } .custom-task-wrapper > * { display: block; overflow: hidden; text-overflow: ellipsis; } .custom-task-img-wrapper { float: left; width: 32px; height: 32px; border-radius: 50%; margin: 8px; background-color: #fff; overflow: hidden; } .custom-task-img { width: 32px; } .custom-task-title { font-weight: 600; font-size: 13px; } .custom-task-row { font-size: 11px; } .custom-task-progress { position: absolute; left: 0; bottom: 0; width: 0%; height: 4px; background: rgba(0, 0, 0, 0.3); } .dx-gantt .dx-row { height: 63px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
const currentDate = new Date(Date.now()); const month = currentDate.getMonth(); const year = currentDate.getFullYear(); export const tasks = [{ id: 1, parentId: 0, title: 'Analysis/Software Requirements', start: new Date(year, month, 1), end: new Date(year, month, 28), progress: 31, }, { id: 2, parentId: 1, title: 'Conduct needs analysis', start: new Date(year, month, 1), end: new Date(year, month, 3), progress: 15, }, { id: 3, parentId: 1, title: 'Draft preliminary software specifications', start: new Date(year, month, 3), end: new Date(year, month, 5), progress: 30, }, { id: 4, parentId: 1, title: 'Review software specifications/budget with team', start: new Date(year, month, 4), end: new Date(year, month, 6), progress: 60, }, { id: 5, parentId: 1, title: 'Incorporate feedback on software specifications', start: new Date(year, month, 6), end: new Date(year, month, 8), progress: 45, }, { id: 6, parentId: 1, title: 'Develop delivery timeline', start: new Date(year, month, 8), end: new Date(year, month, 14), progress: 15, }, { id: 7, parentId: 1, title: 'Obtain approvals to proceed (concept, timeline, budget)', start: new Date(year, month, 14), end: new Date(year, month, 20), progress: 15, }, { id: 8, parentId: 1, title: 'Draft preliminary software specifications', start: new Date(year, month, 20), end: new Date(year, month, 25), progress: 0, }, { id: 9, parentId: 1, title: 'Secure required resources', start: new Date(year, month, 25), end: new Date(year, month, 28), progress: 0, }]; export const dependencies = [{ id: 1, predecessorId: 2, successorId: 3, type: 0, }, { id: 2, predecessorId: 3, successorId: 4, type: 0, }, { id: 3, predecessorId: 4, successorId: 5, type: 0, }, { id: 4, predecessorId: 5, successorId: 6, type: 0, }, { id: 5, predecessorId: 6, successorId: 7, type: 0, }, { id: 6, predecessorId: 7, successorId: 8, type: 0, }, { id: 7, predecessorId: 8, successorId: 9, type: 0, }]; export const resources = [{ id: 1, text: 'John Heart', }, { id: 2, text: 'Paul Peyton', }, { id: 3, text: 'Robert Reagan', }, { id: 4, text: 'Greta Sims', }, { id: 5, text: 'Brett Wade', }, { id: 6, text: 'Sandra Johnson', }, { id: 7, text: 'Kevin Carter', }, { id: 8, text: 'Cynthia Stanwick', }, { id: 9, text: 'Olivia Samuelson', }]; export const resourceAssignments = [{ id: 0, taskId: 1, resourceId: 1, }, { id: 1, taskId: 2, resourceId: 2, }, { id: 2, taskId: 3, resourceId: 3, }, { id: 3, taskId: 4, resourceId: 4, }, { id: 4, taskId: 5, resourceId: 5, }, { id: 5, taskId: 6, resourceId: 6, }, { id: 6, taskId: 7, resourceId: 7, }, { id: 7, taskId: 8, resourceId: 8, }, { id: 8, taskId: 9, resourceId: 9, }];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx-gantt.css" /> <script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

Implementation: Use the taskContentTemplate template to customize and align task information within the template container. For each task, use the item property to obtain task information (title, resource, progress) and wrap it into div elements. Then, apply CSS styles to these div elements and place them into the container.